package org.expeditee.items.MagneticConstraint.Actions;

import org.expeditee.items.Item;
import org.expeditee.items.MagneticConstraint.MagneticConstraintActionWithArguments;
import org.expeditee.items.MagneticConstraint.MagneticConstraints;
import org.expeditee.items.MagneticConstraint.Utilities.Line;

public class AttractTextAction extends
		MagneticConstraintActionWithArguments<Float> {

	@Override
	public boolean exec(Item item) {
		return exec(item, 0f);
	}

	@Override
	public boolean exec(Item item, Float... args) {
		if(item.getParent() == null || item.getText().startsWith("@")) {
			return false;
		}
		if(item.getMagnetizedItemRight() == -1) {
			MagneticConstraints.Log(this.getClass(), new Item[]{item}, 
					Line.getLineContainingToken(item).toArray(new Item[]{}), 
					"No right neighbor to attract.");
			return false;
		} else if (item.getParent().getItemWithID(item.getMagnetizedItemRight()) == null) {
			item.setMagnetizedItemRight(null);
			MagneticConstraints.Log(this.getClass(), new Item[]{item}, 
					Line.getLineContainingToken(item).toArray(new Item[]{}), 
					"Right neighbor has id: " + item.getMagnetizedItemRight() + 
					" according to datastructure but no item on frame has that id.");
			return false;
		}
		else {
			final Item toMyRight = item.getParent().getItemWithID(item.getMagnetizedItemRight());
			float newX = toMyRight.getX() - args[0];
			if(newX < toMyRight.getX()) {
  				System.err.println();
			}
			toMyRight.setX(newX);
			MagneticConstraints.Log(this.getClass(), new Item[]{item, toMyRight}, 
					Line.getLineContainingToken(item).toArray(new Item[]{}), 
					"Attracting second primary to first.  Delta: " + args[0] + ". NewX: " + newX + ". Recursing.");
			new AttractTextAction().exec(toMyRight, args);
			return true;
		}
	}

	@Override
	public boolean invert(Item item) {
		System.err.println("Attract text action does not have a inverted implementation.");
		return false;
	}

}
