package org.expeditee.items.MagneticConstraint.Actions;

import java.awt.event.KeyEvent;

import org.expeditee.gui.DisplayIO;
import org.expeditee.items.Item;
import org.expeditee.items.Text;
import org.expeditee.items.MagneticConstraint.MagneticConstraintAction;
import org.expeditee.items.MagneticConstraint.MagneticConstraints;
import org.expeditee.items.MagneticConstraint.Utilities.TextLogic;

public class DeleteAction extends MagneticConstraintAction {
	
	@Override
	public boolean exec(final Item item) {
		if(TextLogic.XIsAfterCharacters((Text) item, DisplayIO.getMouseX())) {
			if(item.getMagnetizedItemRight() != -1) {
				final Text toMyRight = (Text) item.getParent().getItemWithID(item.getMagnetizedItemRight());
				final int deltaX = TextLogic.DistanceThroughTextWithXCharacters(toMyRight, 1);
				DisplayIO.setCursorPosition((float) toMyRight.getPixelBoundsUnion().getX() + deltaX, DisplayIO.getFloatMouseY());
				MagneticConstraints.getInstance().keyHit(KeyEvent.VK_BACK_SPACE, toMyRight);
				DisplayIO.MoveCursorToEndOfItem(item);
				return true;
			} else if (item.getMagnetizedItemBottom() != -1) {
				final Text belowMe = (Text) item.getParent().getItemWithID(item.getMagnetizedItemBottom());
				DisplayIO.setCursorPosition(belowMe.getPosition());
				MagneticConstraints.getInstance().keyHit(KeyEvent.VK_BACK_SPACE, belowMe);
				return true;
			} else return false;
		} else return false;
	}

	@Override
	public boolean invert(Item item) {
		System.err.println("Delete action does not have a inverted implementation.");
		return false;
	}

}
