package org.expeditee.items.MagneticConstraint.Actions;

import org.expeditee.items.Item;
import org.expeditee.items.MagneticConstraint.MagneticConstraintActionWithArguments;
import org.expeditee.items.MagneticConstraint.MagneticConstraints;
import org.expeditee.items.MagneticConstraint.Utilities.BoxLogic;
import org.expeditee.items.MagneticConstraint.Utilities.Line;

public class RepelTextAction extends
		MagneticConstraintActionWithArguments<Float> {

	@Override
	public boolean exec(final Item item) {
		MagneticConstraints.Log(this.getClass(), new Item[]{item}, 
				Line.getLineContainingToken(item).toArray(new Item[]{}), 
				"YOU SHOULD NOT SEE THIS");
		return exec(item, 0f);
	}

	@Override
	public boolean exec(final Item item, final Float... args) {
		if(item.getParent() == null || item.getText().startsWith("@")) {
			return false;
		}
		if (item.getMagnetizedItemRight() == -1) {
			if(item.getParent() == null) return false;
			if(BoxLogic.boxCollision(item)) {
				callback(null);
				BoxLogic.resolveCollision(item, this);
				callback(null);
				MagneticConstraints.Log(this.getClass(), new Item[]{item}, 
						Line.getLineContainingToken(item).toArray(new Item[]{}), 
						"No item found to right to repel.  Collision occured.");
			} else {
				MagneticConstraints.Log(this.getClass(), new Item[]{item}, 
						Line.getLineContainingToken(item).toArray(new Item[]{}), 
						"No item found to right to repel.");
			}
			return false;
		} else if (item.getParent().getItemWithID(item.getMagnetizedItemRight()) == null) {
			item.setMagnetizedItemRight(null);
			MagneticConstraints.Log(this.getClass(), new Item[]{item}, 
					Line.getLineContainingToken(item).toArray(new Item[]{}), 
					"Right neighbor has id: " + item.getMagnetizedItemRight() + 
					" according to datastructure but no item on frame has that id.");
			return false;
		} else {
			final Item toMyRight = item.getParent().getItemWithID(
					item.getMagnetizedItemRight());
			if(item.getX() + item.getBoundsWidth() + args[0] >= toMyRight.getX()) {
				float newX = toMyRight.getX() + args[0];
				//System.err.println("Repeling item with text: " + toMyRight.getText() + " Origonal X: " + toMyRight.getX() + " New X: " + newX);
				if(newX < toMyRight.getX()) {
					System.err.println();
				}
				toMyRight.setX(newX);
				MagneticConstraints.Log(this.getClass(), new Item[]{item, toMyRight}, 
						Line.getLineContainingToken(item).toArray(new Item[]{}), 
						"Repeling second primary to first.  Delta: " + args[0] + ". NewX: " + newX + ". Recursing.");
				RepelTextAction recurse = new RepelTextAction();
				recurse.setCallbackAction(this.callbackAction);
				recurse.exec(toMyRight, args);
				return true;
			} else return false;
		}
	}

	@Override
	public boolean invert(final Item item) {
		System.err.println("Repel text action does not have a inverted implementation.");
		return false;
	}
}
