package org.expeditee.items;

import java.util.*;

public class Tooltip {
	
	private List<Text> tooltipItems = new LinkedList<Text>();
	
	public Text addTooltip(String content) {
		if(content.trim().toLowerCase().startsWith("text") && content.contains(":")) 
			content = content.substring(content.indexOf(':') + 1);
		final Text tooltip = new Text(content);
		return addTooltip((Text) tooltip.getParentOrCurrentFrame().getTooltipTextItem(content));
	}
	
	public Text addTooltip(final Text tooltip) {
		tooltipItems.add(tooltip);
		return tooltip;
	}
	
	public List<Text> getTooltips() { return tooltipItems; }
	
	public List<String> asStringList() { 
		final List<String> ret = new LinkedList<String>();
		for(final Text tooltip: tooltipItems) ret.add(tooltip.getText());
		return ret;
	}
	
	public int getWidth() {
		int max = 0;
		for(final Text tooltip: tooltipItems) if(tooltip.getBoundsWidth() > max) max = tooltip.getBoundsWidth();
		return max;
	}

	public int getHeight() {
		int max = 0;
		for(final Text tooltip: tooltipItems) if(tooltip.getBoundsWidth() > max) max = tooltip.getBoundsHeight();
		return max;
	}
	
	public int getCollectiveHeight() {
		int height = 0;
		for(final Text tooltip: tooltipItems) height += tooltip.getBoundsHeight();
		return height;
	}
}
